/* dmxutil.c
 * 
 * Copyright (C) 2002 Claudio Girardi  <in3otd@qsl.net>
 * 
 * This file was derived from the original Pascal code, written by
 * Stephen A. Maas. It was translated into ANSI C with the help of p2c,
 * version 1.21alpha, and further manually refined by Claudio Girardi.
 * 
 * Bugs were certainly introduced during the translation process, so
 * please don't bother Sthephen with bug reports but send them to
 * Claudio, thanks.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA, 02111-1307, USA
 */


/* Original file: DMXUTIL.PAS */

#include <stdio.h>
#include "diodemx.h"
#include "dmxutil.h"


#define a               440
#define c_sh            550
#define e               660
#define a2              880
#define x_              150


void arpeggio(void)
{
  /* sorry, no sound for the C version ... */
}

#undef a
#undef c_sh
#undef e
#undef a2
#undef x_


void CAP(char *x)
{
  if (*x > 96 && *x < 123)	/* x is lower-case */
    *x -= 32;
}


void CapStr(char *x)
{
  short j, FORLIM;

  FORLIM = strlen(x);
  for (j = 0; j <= FORLIM - 1; j++)
    CAP(&x[j]);
}


static void strdelete(char *st, int from, int n)
{
  int i, nchar;

  nchar = strlen(st);

  for (i = from - 1; i < nchar - n; i++) {
    st[i] = st[i + n];
  }
  st[nchar - n] = '\0';
}


void RemoveSpaces(char *st)
{

  /*Removes leading and trailing spaces from a string */
  do {
    if (st[0] == ' ')
      strdelete((void *) st, 1, 1);
  } while (st[0] == ' ' && *st != '\0');
  do {
    if (st[strlen(st) - 1] == ' ')
      strdelete((void *) st, strlen(st), 1);
  } while (st[strlen(st) - 1] == ' ' && *st != '\0');
}


void ReadStr(FILE ** fvar, char *strx, boolean * LastItem)
{

  /*Reads the next item on a line of a text file, and returns it as a string;
     the string has no leading or trailing spaces.  If it is the last item,
     LastItem is set to true; otherwise false. */
  char ch = ' ';

  *strx = '\0';
  *LastItem = false;
  while (ch == ' ' && ch != '\n') {
    ch = getc(*fvar);
    if (ch != ' ') {
      sprintf(strx + strlen(strx), "%c", ch);
/* p2c: dmxutil.pas, line 61:
 * Note: Possible string truncation in assignment [145] */
    }
  }
  if (ch != '\n') {
    do {
      ch = getc(*fvar);
      if (ch != ' ') {
	sprintf(strx + strlen(strx), "%c", ch);
/* p2c: dmxutil.pas, line 66:
 * Note: Possible string truncation in assignment [145] */
      }
    } while (!(ch == ' ' || ch == '\n'));
  }
  if (ch == '\n')
    *LastItem = true;
}
